{###############################################################################
# Dipesh-TxtEdit-32 Version 1.xx.xx                         Delphi 3 Quellcode #
################################################################################
# Programmiert & Entwickelt von Sebastian Sauer (Dipesh)                       #
# E-Mail: dipesh@gmx.de                                                        #
# Homepage: http://members.tripod.de/dipesh4                                   #
################################################################################
# GLOBALS.PAS                                                                  #
###############################################################################}

UNIT Globals;

INTERFACE

Uses Windows, SysUtils, Forms, ShellApi;

Const
  DTE32_Version                             = '1.01';
  DTE_Build                                 = '01.07.1999';
  IniFileCom: string                        = 'DTE32.ini';
  SingleInstance: boolean                   = false;
  Window_Width: integer                     = -1;
  Window_Height: integer                    = -1;
  Window_State: twindowstate                = wsNormal;
  ShowMarkLeiste: boolean                   = true;
  StartWithNewDoc: boolean                  = false;
  UseAutoUrls: boolean                      = true;
  IfReadOnlyThenNurLesenZulassen: boolean   = false;
  SaveSettingsOnExit: boolean               = true;
  LoadSaveOpenFiles: boolean                = false;
  IsFirstOnActivate: boolean                = true;
  
function FormatInteger(FormatInt: longint): string;
function GetProcent(BigInt, SmallInt: integer): integer;
function FileIsReadOnly(FileCom: string): boolean;
procedure ExecuteFile(ExecuteCom, ExecuteParams: string);

IMPLEMENTATION

function FormatInteger(FormatInt: longint): string;
var FI_LongInt1: longint;
begin
  Result:=IntToStr(FormatInt); FI_LongInt1:=3;
  While Length(Result)>FI_LongInt1 do begin Insert('.',Result,Length(Result)-FI_LongInt1+1); inc(FI_LongInt1,4); end;
end;

function GetProcent(BigInt, SmallInt: integer): integer;
var ExtReal1, ExtReal2: extended;
begin Try ExtReal1:=BigInt; ExtReal2:=SmallInt; Result:=Round((ExtReal2 * 100) / ExtReal1); Except Result:=0; end; end;

function FileIsReadOnly(FileCom: string): boolean;
var FIRO_TSR: TSearchRec;
begin
  If FindFirst(FileCom,faAnyFile,FIRO_TSR)=0 then Result:=(FIRO_TSR.Attr and faReadOnly > 0) else Result:=false;
  FindClose(FIRO_TSR);
end;

procedure ExecuteFile(ExecuteCom, ExecuteParams: string);
var EF_Int1: integer; EF_Str1: string;
begin
  Try EF_Int1:=ShellExecute(Application.MainForm.Handle,nil,Pchar(ExtractFileName(ExecuteCom)),Pchar(ExecuteParams),Pchar(ExtractFilePath(ExecuteCom)),SW_SHOWNORMAL);
  Finally
    If EF_Int1<=32 then begin Case EF_Int1 of
      0: EF_Str1:='Nicht gengend freier Speicher bzw. freie Resourcen.';
      ERROR_FILE_NOT_FOUND: EF_Str1:='Datei konnte nicht gefunden werden.';
      ERROR_PATH_NOT_FOUND: EF_Str1:='Verzeichnis konnte nicht gefunden werden.';
      ERROR_BAD_FORMAT: EF_Str1:='Die EXE-Datei ist fehlerhaft oder ungltig.';
      SE_ERR_ACCESSDENIED: EF_Str1:='Das Betriebssystem hat keinen Zugriff auf die spezifizierte Datei.';
      SE_ERR_ASSOCINCOMPLETE: EF_Str1:='Der angegebene Dateiname ist ungltig oder unkomplet.';
      SE_ERR_DDEBUSY: EF_Str1:='DDE-Konversation schlug fehl, da z.Z. eine andere DDE-Transaktion aktiv ist.';
      SE_ERR_DDEFAIL: EF_Str1:='DDE-Konversation schlug fehl.';
      SE_ERR_DDETIMEOUT: EF_Str1:='DDE-Konversation schlug fehl, da zugestandene Zeit berschritten wurde.';
      SE_ERR_DLLNOTFOUND: EF_Str1:='Die spezifizierte Dynamik-Link-Library konnte nicht gefunden werden.';
      SE_ERR_NOASSOC: EF_Str1:='Dieser Dateierweiterung ist kein Programm zugeordnet.';
      SE_ERR_OOM: EF_Str1:='Nicht gengend freier Speicher um die Operation durchzufhren.';
      SE_ERR_SHARE: EF_Str1:='Windows-Schutzverletzung.';
      else EF_Str1:='Unbekannter Fehler. Aktion konnte nicht durchgefhrt werden.';
    end; end else EF_Str1:='';
    If EF_Str1>'' then MessageBox(0,PChar(EF_Str1),'Fehler: Ausfhrung fehlgeschlagen...',MB_IconStop+MB_Ok+MB_SetForeground+MB_ApplModal);
  end;
end;

END.
